// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from polygon_msgs:msg/ComplexPolygon2DStamped.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "polygon_msgs/msg/complex_polygon2_d_stamped.h"


#ifndef POLYGON_MSGS__MSG__DETAIL__COMPLEX_POLYGON2_D_STAMPED__FUNCTIONS_H_
#define POLYGON_MSGS__MSG__DETAIL__COMPLEX_POLYGON2_D_STAMPED__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "polygon_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "polygon_msgs/msg/detail/complex_polygon2_d_stamped__struct.h"

/// Initialize msg/ComplexPolygon2DStamped message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * polygon_msgs__msg__ComplexPolygon2DStamped
 * )) before or use
 * polygon_msgs__msg__ComplexPolygon2DStamped__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__ComplexPolygon2DStamped__init(polygon_msgs__msg__ComplexPolygon2DStamped * msg);

/// Finalize msg/ComplexPolygon2DStamped message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
void
polygon_msgs__msg__ComplexPolygon2DStamped__fini(polygon_msgs__msg__ComplexPolygon2DStamped * msg);

/// Create msg/ComplexPolygon2DStamped message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * polygon_msgs__msg__ComplexPolygon2DStamped__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
polygon_msgs__msg__ComplexPolygon2DStamped *
polygon_msgs__msg__ComplexPolygon2DStamped__create(void);

/// Destroy msg/ComplexPolygon2DStamped message.
/**
 * It calls
 * polygon_msgs__msg__ComplexPolygon2DStamped__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
void
polygon_msgs__msg__ComplexPolygon2DStamped__destroy(polygon_msgs__msg__ComplexPolygon2DStamped * msg);

/// Check for msg/ComplexPolygon2DStamped message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__ComplexPolygon2DStamped__are_equal(const polygon_msgs__msg__ComplexPolygon2DStamped * lhs, const polygon_msgs__msg__ComplexPolygon2DStamped * rhs);

/// Copy a msg/ComplexPolygon2DStamped message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__ComplexPolygon2DStamped__copy(
  const polygon_msgs__msg__ComplexPolygon2DStamped * input,
  polygon_msgs__msg__ComplexPolygon2DStamped * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
const rosidl_type_hash_t *
polygon_msgs__msg__ComplexPolygon2DStamped__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
const rosidl_runtime_c__type_description__TypeDescription *
polygon_msgs__msg__ComplexPolygon2DStamped__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
const rosidl_runtime_c__type_description__TypeSource *
polygon_msgs__msg__ComplexPolygon2DStamped__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
polygon_msgs__msg__ComplexPolygon2DStamped__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/ComplexPolygon2DStamped messages.
/**
 * It allocates the memory for the number of elements and calls
 * polygon_msgs__msg__ComplexPolygon2DStamped__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__ComplexPolygon2DStamped__Sequence__init(polygon_msgs__msg__ComplexPolygon2DStamped__Sequence * array, size_t size);

/// Finalize array of msg/ComplexPolygon2DStamped messages.
/**
 * It calls
 * polygon_msgs__msg__ComplexPolygon2DStamped__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
void
polygon_msgs__msg__ComplexPolygon2DStamped__Sequence__fini(polygon_msgs__msg__ComplexPolygon2DStamped__Sequence * array);

/// Create array of msg/ComplexPolygon2DStamped messages.
/**
 * It allocates the memory for the array and calls
 * polygon_msgs__msg__ComplexPolygon2DStamped__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
polygon_msgs__msg__ComplexPolygon2DStamped__Sequence *
polygon_msgs__msg__ComplexPolygon2DStamped__Sequence__create(size_t size);

/// Destroy array of msg/ComplexPolygon2DStamped messages.
/**
 * It calls
 * polygon_msgs__msg__ComplexPolygon2DStamped__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
void
polygon_msgs__msg__ComplexPolygon2DStamped__Sequence__destroy(polygon_msgs__msg__ComplexPolygon2DStamped__Sequence * array);

/// Check for msg/ComplexPolygon2DStamped message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__ComplexPolygon2DStamped__Sequence__are_equal(const polygon_msgs__msg__ComplexPolygon2DStamped__Sequence * lhs, const polygon_msgs__msg__ComplexPolygon2DStamped__Sequence * rhs);

/// Copy an array of msg/ComplexPolygon2DStamped messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__ComplexPolygon2DStamped__Sequence__copy(
  const polygon_msgs__msg__ComplexPolygon2DStamped__Sequence * input,
  polygon_msgs__msg__ComplexPolygon2DStamped__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // POLYGON_MSGS__MSG__DETAIL__COMPLEX_POLYGON2_D_STAMPED__FUNCTIONS_H_
